/* MCP3428 ADC cont sample CH4 SE (15 bit) 15SPS 1V/V
 
 I2C SDA  ==> A4/P1_7  Arduino/Energia
 I2C SCL  ==> A5/P1_6  Arduino/Energia
 
 CONF_REG[7..0]  !RDY  C1  C0  !O/C  S1  S0  G1  G0
 
 !RDY WR=1 CNV, RD=0 RDY ADC
 C1/C0 ADCMUX 00..11 / 0-3 sel
 !0/C CNV type !O/C= 1 cont, !O/C=0 one shoot
 S1/S0 SR 00 240SPS/12bit, 01 60SPS/14bit, 10 15SPS/16bit
 G1/G0 gain select 00=1, 01=2, 10=4, 11=8 [V/V]
 Vref = 2.048V
 Diff +/-2^15, Single 0-2^15 (one bit cut - sign)
 write I2C [ADR][CONF_REG]
 read  I2C [ADR][HIGH_ADC][LOW_ADC][CONF_REG]<CONF_REG>
 */

#include <Wire.h>

#define MCP3428_ADR       B1101000     // 7bit MCP3428 device address A1,A0=00
#define MCP3428_CONF_REG  B11111000    // MCP config

byte reg = 0;
uint8_t result_H=0, result_L =0;

void setup() {
  Serial.begin(9600);
  Wire.begin();
  Wire.beginTransmission(MCP3428_ADR);
  Wire.write(MCP3428_CONF_REG); 
  Wire.endTransmission();   
}

void loop() {

  Wire.beginTransmission(MCP3428_ADR);  
  Wire.requestFrom(MCP3428_ADR, 3);      // request 3 bytes from MCP 

  while(Wire.available()) {      
    result_H = Wire.read();          // HIGH_ADC
    result_L = Wire.read();          // LOW_ADC
    reg = Wire.read();               // CONF_REG
    Serial.print(" CFG: "); 
    Serial.print(reg, HEX); 
    Serial.print(" ADCH/L: "); 
    Serial.print(result_H, HEX); 
    Serial.print(":"); 
    Serial.println(result_L, HEX); 
  }
  Wire.endTransmission();
  delay(1000);
}




